diff --git a/liboctave/operators/mx-inlines.cc b/liboctave/operators/mx-inlines.cc
--- a/liboctave/operators/mx-inlines.cc
+++ b/liboctave/operators/mx-inlines.cc
@@ -392,15 +392,6 @@ mx_inline_xmax (size_t n, T *r, T x, con
     else                                                        \
       for (size_t i = 0; i < n; i++)                            \
         r[i] = (x[i] OP y) ? x[i] : y;                          \
-  }                                                             \
-  template <>                                                   \
-  inline void F<T> (size_t n, T *r, T x, const T *y) throw ()   \
-  {                                                             \
-    if (octave::math::isnan (x))                                \
-      std::memcpy (r, y, n * sizeof (T));                       \
-    else                                                        \
-      for (size_t i = 0; i < n; i++)                            \
-        r[i] = (y[i] OP x) ? y[i] : x;                          \
   }
 
 DEFMINMAXSPEC (double, mx_inline_xmin, <=)
@@ -408,6 +399,60 @@ DEFMINMAXSPEC (double, mx_inline_xmax, >
 DEFMINMAXSPEC (float, mx_inline_xmin, <=)
 DEFMINMAXSPEC (float, mx_inline_xmax, >=)
 
+template <typename T>
+inline void
+mx_inline_xmin_inan (size_t n, T *r, const T *x, const T *y) throw ()
+{
+  for (size_t i = 0; i < n; i++)
+    r[i] = x[i] <= y[i] ? x[i] : (octave::math::isnan (x[i]) ? x[i] : y[i]);
+}
+
+template <typename T>
+inline void
+mx_inline_xmin_inan (size_t n, T *r, const T *x, T y) throw ()
+{
+  for (size_t i = 0; i < n; i++)
+    r[i] = x[i] <= y ? x[i] : (octave::math::isnan (x[i]) ? x[i] : y);
+}
+
+template <typename T>
+inline void
+mx_inline_xmin_inan (size_t n, T *r, T x, const T *y) throw ()
+{
+  if (octave::math::isnan (x))
+    std::fill_n (r, n, x);
+  else
+    for (size_t i = 0; i < n; i++)
+      r[i] = x <= y[i] ? x : y[i];
+}
+
+template <typename T>
+inline void
+mx_inline_xmax_inan (size_t n, T *r, const T *x, const T *y) throw ()
+{
+  for (size_t i = 0; i < n; i++)
+    r[i] = x[i] >= y[i] ? x[i] : (octave::math::isnan (x[i]) ? x[i] : y[i]);
+}
+
+template <typename T>
+inline void
+mx_inline_xmax_inan (size_t n, T *r, const T *x, T y) throw ()
+{
+  for (size_t i = 0; i < n; i++)
+    r[i] = x[i] >= y ? x[i] : (octave::math::isnan (x[i]) ? x[i] : y);
+}
+
+template <typename T>
+inline void
+mx_inline_xmax_inan (size_t n, T *r, T x, const T *y) throw ()
+{
+  if (octave::math::isnan (x))
+    std::fill_n (r, n, x);
+  else
+    for (size_t i = 0; i < n; i++)
+      r[i] = x >= y[i] ? x : y[i];
+}
+
 // Let the compiler decide which pow to use, whichever best matches the
 // arguments provided.
 
@@ -934,46 +979,89 @@ OP_CUM_FCNN (mx_inline_cumcount, bool, T
 
 #define OP_MINMAX_FCN(F, OP)                                            \
   template <typename T>                                                 \
-  void F (const T *v, T *r, octave_idx_type n)                          \
+  void F (const T *v, T *r, octave_idx_type n, bool includenan)         \
   {                                                                     \
     if (! n)                                                            \
       return;                                                           \
     T tmp = v[0];                                                       \
     octave_idx_type i = 1;                                              \
-    if (octave::math::isnan (tmp))                                      \
+    if (includenan)                                                     \
       {                                                                 \
-        for (; i < n && octave::math::isnan (v[i]); i++) ;              \
-        if (i < n)                                                      \
-          tmp = v[i];                                                   \
+        if (! octave::math::isnan (tmp))                                \
+          {                                                             \
+            for (; i < n; i++)                                          \
+              {                                                         \
+                if (octave::math::isnan (v[i]))                         \
+                  {                                                     \
+                    tmp = v[i];                                         \
+                    break;                                              \
+                  }                                                     \
+                if (v[i] OP tmp)                                        \
+                  tmp = v[i];                                           \
+              }                                                         \
+          }                                                             \
       }                                                                 \
-    for (; i < n; i++)                                                  \
-      if (v[i] OP tmp)                                                  \
-        tmp = v[i];                                                     \
+    else                                                                \
+      {                                                                 \
+        if (octave::math::isnan (tmp))                                  \
+          {                                                             \
+            for (; i < n && octave::math::isnan (v[i]); i++) ;          \
+            if (i < n)                                                  \
+              tmp = v[i];                                               \
+          }                                                             \
+        for (; i < n; i++)                                              \
+          if (v[i] OP tmp)                                              \
+            tmp = v[i];                                                 \
+      }                                                                 \
     *r = tmp;                                                           \
   }                                                                     \
   template <typename T>                                                 \
-  void F (const T *v, T *r, octave_idx_type *ri, octave_idx_type n)     \
+  void F (const T *v, T *r, octave_idx_type *ri, octave_idx_type n,     \
+          bool includenan)                                              \
   {                                                                     \
     if (! n)                                                            \
       return;                                                           \
     T tmp = v[0];                                                       \
     octave_idx_type tmpi = 0;                                           \
     octave_idx_type i = 1;                                              \
-    if (octave::math::isnan (tmp))                                      \
+    if (includenan)                                                     \
       {                                                                 \
-        for (; i < n && octave::math::isnan (v[i]); i++) ;              \
-        if (i < n)                                                      \
+        if (! octave::math::isnan (tmp))                                \
           {                                                             \
-            tmp = v[i];                                                 \
-            tmpi = i;                                                   \
+            for (; i < n; i++)                                          \
+              {                                                         \
+                if (octave::math::isnan (v[i]))                         \
+                  {                                                     \
+                    tmp = v[i];                                         \
+                    tmpi = i;                                           \
+                    break;                                              \
+                  }                                                     \
+                if (v[i] OP tmp)                                        \
+                  {                                                     \
+                    tmp = v[i];                                         \
+                    tmpi = i;                                           \
+                  }                                                     \
+              }                                                         \
           }                                                             \
       }                                                                 \
-    for (; i < n; i++)                                                  \
-      if (v[i] OP tmp)                                                  \
-        {                                                               \
-          tmp = v[i];                                                   \
-          tmpi = i;                                                     \
-        }                                                               \
+    else                                                                \
+      {                                                                 \
+        if (octave::math::isnan (tmp))                                  \
+          {                                                             \
+            for (; i < n && octave::math::isnan (v[i]); i++) ;          \
+            if (i < n)                                                  \
+              {                                                         \
+                tmp = v[i];                                             \
+                tmpi = i;                                               \
+              }                                                         \
+          }                                                             \
+        for (; i < n; i++)                                              \
+          if (v[i] OP tmp)                                              \
+            {                                                           \
+              tmp = v[i];                                               \
+              tmpi = i;                                                 \
+            }                                                           \
+      }                                                                 \
     *r = tmp;                                                           \
     *ri = tmpi;                                                         \
   }
@@ -988,86 +1076,170 @@ OP_MINMAX_FCN (mx_inline_max, >)
 #define OP_MINMAX_FCN2(F, OP)                                           \
   template <typename T>                                                 \
   inline void                                                           \
-  F (const T *v, T *r, octave_idx_type m, octave_idx_type n)            \
+  F (const T *v, T *r, octave_idx_type m, octave_idx_type n,            \
+     bool includenan)                                                   \
   {                                                                     \
     if (! n)                                                            \
       return;                                                           \
-    bool nan = false;                                                   \
-    octave_idx_type j = 0;                                              \
-    for (octave_idx_type i = 0; i < m; i++)                             \
+    if (includenan)                                                     \
       {                                                                 \
-        r[i] = v[i];                                                    \
-        if (octave::math::isnan (v[i]))                                 \
-          nan = true;                                                   \
-      }                                                                 \
-    j++;                                                                \
-    v += m;                                                             \
-    while (nan && j < n)                                                \
-      {                                                                 \
-        nan = false;                                                    \
+        octave_idx_type prev = 0;                                       \
+        OCTAVE_LOCAL_BUFFER (octave_idx_type, next, m + 1);             \
+        next[0] = 0;                                                    \
         for (octave_idx_type i = 0; i < m; i++)                         \
           {                                                             \
+            r[i] = v[i];                                                \
+            if (! octave::math::isnan (v[i]))                           \
+              prev = i + 1;                                             \
+            next[prev] = i + 1;                                         \
+          }                                                             \
+        v += m;                                                         \
+        for (octave_idx_type j = 1; j < n; j++)                         \
+          {                                                             \
+            prev = 0;                                                   \
+            for (octave_idx_type i = next[0]; i < m; i = next[i + 1])   \
+              {                                                         \
+                if (octave::math::isnan (v[i]))                         \
+                  {                                                     \
+                    r[i] = v[i];                                        \
+                    next[prev] = next[i + 1];                           \
+                  }                                                     \
+                else                                                    \
+                  {                                                     \
+                    if (v[i] OP r[i])                                   \
+                      r[i] = v[i];                                      \
+                    prev = i + 1;                                       \
+                  }                                                     \
+              }                                                         \
+            v += m;                                                     \
+          }                                                             \
+      }                                                                 \
+    else                                                                \
+      {                                                                 \
+        bool nan = false;                                               \
+        octave_idx_type j = 0;                                          \
+        for (octave_idx_type i = 0; i < m; i++)                         \
+          {                                                             \
+            r[i] = v[i];                                                \
             if (octave::math::isnan (v[i]))                             \
               nan = true;                                               \
-            else if (octave::math::isnan (r[i]) || v[i] OP r[i])        \
-              r[i] = v[i];                                              \
           }                                                             \
         j++;                                                            \
         v += m;                                                         \
-      }                                                                 \
-    while (j < n)                                                       \
-      {                                                                 \
-        for (octave_idx_type i = 0; i < m; i++)                         \
-          if (v[i] OP r[i])                                             \
-            r[i] = v[i];                                                \
-        j++;                                                            \
-        v += m;                                                         \
+        while (nan && j < n)                                            \
+          {                                                             \
+            nan = false;                                                \
+            for (octave_idx_type i = 0; i < m; i++)                     \
+              {                                                         \
+                if (octave::math::isnan (v[i]))                         \
+                  {                                                     \
+                    if (octave::math::isnan (r[i]))                     \
+                      nan = true;                                       \
+                  }                                                     \
+                else if (octave::math::isnan (r[i]) || v[i] OP r[i])    \
+                  r[i] = v[i];                                          \
+              }                                                         \
+            j++;                                                        \
+            v += m;                                                     \
+          }                                                             \
+        while (j < n)                                                   \
+          {                                                             \
+            for (octave_idx_type i = 0; i < m; i++)                     \
+              if (v[i] OP r[i])                                         \
+                r[i] = v[i];                                            \
+            j++;                                                        \
+            v += m;                                                     \
+          }                                                             \
       }                                                                 \
   }                                                                     \
   template <typename T>                                                 \
   inline void                                                           \
   F (const T *v, T *r, octave_idx_type *ri,                             \
-     octave_idx_type m, octave_idx_type n)                              \
+     octave_idx_type m, octave_idx_type n, bool includenan)             \
   {                                                                     \
     if (! n)                                                            \
       return;                                                           \
-    bool nan = false;                                                   \
-    octave_idx_type j = 0;                                              \
-    for (octave_idx_type i = 0; i < m; i++)                             \
+    if (includenan)                                                     \
       {                                                                 \
-        r[i] = v[i];                                                    \
-        ri[i] = j;                                                      \
-        if (octave::math::isnan (v[i]))                                 \
-          nan = true;                                                   \
-      }                                                                 \
-    j++;                                                                \
-    v += m;                                                             \
-    while (nan && j < n)                                                \
-      {                                                                 \
-        nan = false;                                                    \
+        octave_idx_type prev = 0;                                       \
+        OCTAVE_LOCAL_BUFFER (octave_idx_type, next, m + 1);             \
+        next[0] = 0;                                                    \
         for (octave_idx_type i = 0; i < m; i++)                         \
           {                                                             \
+            r[i] = v[i];                                                \
+            ri[i] = 0;                                                  \
+            if (! octave::math::isnan (v[i]))                           \
+              prev = i + 1;                                             \
+            next[prev] = i + 1;                                         \
+          }                                                             \
+        v += m;                                                         \
+        for (octave_idx_type j = 1; j < n; j++)                         \
+          {                                                             \
+            prev = 0;                                                   \
+            for (octave_idx_type i = next[0]; i < m; i = next[i + 1])   \
+              {                                                         \
+                if (octave::math::isnan (v[i]))                         \
+                  {                                                     \
+                    r[i] = v[i];                                        \
+                    ri[i] = j;                                          \
+                    next[prev] = next[i + 1];                           \
+                  }                                                     \
+                else                                                    \
+                  {                                                     \
+                    if (v[i] OP r[i])                                   \
+                      {                                                 \
+                        r[i] = v[i];                                    \
+                        ri[i] = j;                                      \
+                      }                                                 \
+                    prev = i + 1;                                       \
+                  }                                                     \
+              }                                                         \
+            v += m;                                                     \
+          }                                                             \
+      }                                                                 \
+    else                                                                \
+      {                                                                 \
+        bool nan = false;                                               \
+        octave_idx_type j = 0;                                          \
+        for (octave_idx_type i = 0; i < m; i++)                         \
+          {                                                             \
+            r[i] = v[i];                                                \
+            ri[i] = j;                                                  \
             if (octave::math::isnan (v[i]))                             \
               nan = true;                                               \
-            else if (octave::math::isnan (r[i]) || v[i] OP r[i])        \
-              {                                                         \
-                r[i] = v[i];                                            \
-                ri[i] = j;                                              \
-              }                                                         \
           }                                                             \
         j++;                                                            \
         v += m;                                                         \
-      }                                                                 \
-    while (j < n)                                                       \
-      {                                                                 \
-        for (octave_idx_type i = 0; i < m; i++)                         \
-          if (v[i] OP r[i])                                             \
-            {                                                           \
-              r[i] = v[i];                                              \
-              ri[i] = j;                                                \
-            }                                                           \
-        j++;                                                            \
-        v += m;                                                         \
+        while (nan && j < n)                                            \
+          {                                                             \
+            nan = false;                                                \
+            for (octave_idx_type i = 0; i < m; i++)                     \
+              {                                                         \
+                if (octave::math::isnan (v[i]))                         \
+                  {                                                     \
+                    if (octave::math::isnan (r[i]))                     \
+                      nan = true;                                       \
+                  }                                                     \
+                else if (octave::math::isnan (r[i]) || v[i] OP r[i])    \
+                  {                                                     \
+                    r[i] = v[i];                                        \
+                    ri[i] = j;                                          \
+                  }                                                     \
+              }                                                         \
+            j++;                                                        \
+            v += m;                                                     \
+          }                                                             \
+        while (j < n)                                                   \
+          {                                                             \
+            for (octave_idx_type i = 0; i < m; i++)                     \
+              if (v[i] OP r[i])                                         \
+                {                                                       \
+                  r[i] = v[i];                                          \
+                  ri[i] = j;                                            \
+                }                                                       \
+            j++;                                                        \
+            v += m;                                                     \
+          }                                                             \
       }                                                                 \
   }
 
@@ -1078,7 +1250,8 @@ OP_MINMAX_FCN2 (mx_inline_max, >)
   template <typename T>                                         \
   inline void                                                   \
   F (const T *v, T *r, octave_idx_type l,                       \
-     octave_idx_type n, octave_idx_type u)                      \
+     octave_idx_type n, octave_idx_type u,                      \
+     bool includenan)                                           \
   {                                                             \
     if (! n)                                                    \
       return;                                                   \
@@ -1086,7 +1259,7 @@ OP_MINMAX_FCN2 (mx_inline_max, >)
       {                                                         \
         for (octave_idx_type i = 0; i < u; i++)                 \
           {                                                     \
-            F (v, r, n);                                        \
+            F (v, r, n, includenan);                            \
             v += n;                                             \
             r++;                                                \
           }                                                     \
@@ -1095,7 +1268,7 @@ OP_MINMAX_FCN2 (mx_inline_max, >)
       {                                                         \
         for (octave_idx_type i = 0; i < u; i++)                 \
           {                                                     \
-            F (v, r, l, n);                                     \
+            F (v, r, l, n, includenan);                         \
             v += l*n;                                           \
             r += l;                                             \
           }                                                     \
@@ -1104,14 +1277,15 @@ OP_MINMAX_FCN2 (mx_inline_max, >)
   template <typename T>                                         \
   inline void                                                   \
   F (const T *v, T *r, octave_idx_type *ri,                     \
-     octave_idx_type l, octave_idx_type n, octave_idx_type u)   \
+     octave_idx_type l, octave_idx_type n, octave_idx_type u,   \
+     bool includenan)                                           \
   {                                                             \
     if (! n) return;                                            \
     if (l == 1)                                                 \
       {                                                         \
         for (octave_idx_type i = 0; i < u; i++)                 \
           {                                                     \
-            F (v, r, ri, n);                                    \
+            F (v, r, ri, n, includenan);                        \
             v += n;                                             \
             r++;                                                \
             ri++;                                               \
@@ -1121,7 +1295,7 @@ OP_MINMAX_FCN2 (mx_inline_max, >)
       {                                                         \
         for (octave_idx_type i = 0; i < u; i++)                 \
           {                                                     \
-            F (v, r, ri, l, n);                                 \
+            F (v, r, ri, l, n, includenan);                     \
             v += l*n;                                           \
             r += l;                                             \
             ri += l;                                            \
@@ -1134,7 +1308,7 @@ OP_MINMAX_FCNN (mx_inline_max)
 
 #define OP_CUMMINMAX_FCN(F, OP)                                         \
   template <typename T>                                                 \
-  void F (const T *v, T *r, octave_idx_type n)                          \
+  void F (const T *v, T *r, octave_idx_type n, bool includenan)         \
   {                                                                     \
     if (! n)                                                            \
       return;                                                           \
